# Changelog

All notable changes to this project will be documented in this file.

## [0.3.0] - 2022-09-13

### Bug Fixes

- Accept a byteslice for the pickle key
- Hide the remove_one_time_key method
- Abort unpickling if we have too many one-time keys
- Use overflowing addition when incrementing key ids

### Documentation

- Fix some typos and improve the InboundGroupSession docs
- Clarify wording in OTK comment

### Features

- Add Debug and PartialEq implementations to MegolmMessage
- Add a bunch of missing Eq imlpementations
- Add TryFrom implementations for session keys
- Allow GroupSessions to be unpickled from libolm pickles
- Encode/decode bytes directly in Olm (no string wrapping)
- Encode/decode bytes directly in megolm (no string wrapping)
- Allow megolm messages to be cloned
- Add a method to check if two inbound group sessions are connected
- Add a method to compare two inbound group sessions
- Add support to not truncate MAC tags when encrypting messages
- Implement Display for the public key types
- Implement zeroize for the SessionKey

### Refactor

- Remove the encoded public key from the curve25519 types
- Remove the encoded public key methods
- Remove the encoded one-time keys method
- Create a LibolmEd25519Keypair struct
- Move the libolm RatchetPickle to a common module
- Move the libolm unpickling structs out of the method
- Improve the Debug implementation for SessionKeys
- Refrain from repeating method call.
- Group the session key methods correctly

<!-- generated by git-cliff -->
